<?php
/**
 * @package FanCaiJi
 * @version 1.0.0
 */
/*
Plugin Name: WP防止采集助手
Plugin URI: http://seopuzi.com/fangcaiji/
Description: 被采集时，在内容中插入指定内容，使用教程：http://seopuzi.com/fangcaiji/
Author: 头条捕手
Version: 1.0.0
Author URI: http://seopuzi.com/
*/

defined( 'WPINC' ) || die( '你来错地方了!' );

function filter_ips() {
	$ipstr = array(
		"123.123.123.123",
		"124.123.124.124",
		"127.0.0.1",
		/*
		这里可以插入更多IP，根据上面格式添加
		*/
	);
	return array_filter($ipstr);
}

function insert_content($content,$count=1) {
	/*
	插入广告代码，可以是html或文本
	*/
	$ads = array(
		"！！！！！广告内容1！！！！",
		"！！！！！广告内容2！！！！",
		"！！！！！广告内容3！！！！",
		"！！！！！广告内容4！！！！",
		"！！！！！广告内容5！！！！",
	);
	//随机抽取3条
	$nads = array_rand($ads,3);
	foreach($nads as $n){
		$content = rand_in_str($content,$ads[$n]);
	}
	return $content;
}

function rand_in_str($txt,$insert){
	preg_match_all("/[\x01-\x7f]|[\xe0-\xef][\x80-\xbf]{2}/", $txt, $match);
	$delay=array();
	$add=0;
	foreach($match[0] as $k=>$v){
		if($v=='<') $add=1;
		if($add==1) $delay[]=$k;
		if($v=='>') $add=0;
	}
	$str_arr=$match[0];
	$len=count($str_arr);
	if(is_array($insert)){
		foreach($insert as $k=>$v){
			$insertk=insertK($len-1,$delay);
			$str_arr[$insertk].=$insert[$k];
		}
	}
	else{
		$insertk=insertK($len-1,$delay);
		$str_arr[$insertk].=$insert;
	}
	return join('',$str_arr);
}

function insertK($count,$delay){
	$insertk=rand(0,$count);
	if(in_array($insertk,$delay)){
		$insertk = insertK($count,$delay);
	}
	return $insertk;
}

function get_the_client_ip() {
	if ( ! empty( $_SERVER['HTTP_CLIENT_IP'] ) ) {
		$ip = $_SERVER['HTTP_CLIENT_IP'];
	} elseif ( ! empty( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ) {
		$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
	} else {
		$ip = $_SERVER['REMOTE_ADDR'];
	}
	return apply_filters( 'wpb_get_ip', $ip );
}

function filter_and_change_content($content) {
	$ips = filter_ips();
	$client_ip = get_the_client_ip();
	if ( in_array($client_ip, $ips) && is_single()) {
		$content = insert_content($content);
	}
	return $content;
}

add_filter( 'the_content', 'filter_and_change_content');
?>